window.Gleam.initSearch([{"doc":"novdom","title":"novdom","content":"# novdom\n\n❗️❗️DISCLAIMER: This project is in a very early stage and is not ready for production use.❗️❗️\n\nAn easy to use frontend framework written in Gleam.\n\nNo use of a virtual DOM to ensure the best performance possible.\n\nUse [lustre_dev_tools](https://hexdocs.pm/lustre_dev_tools/index.html) for building / bundling and hot reloading.\n\n# prequisites\n\n- [gleam](https://gleam.run/getting-started/installing/)\n- [bun](https://bun.sh/docs/installation)\n- [nodejs](https://nodejs.org/en/download/prebuilt-installer) (for testing)\n\n# getting started\n\n- clone the repo\n- run `bun install`\n- run `gleam deps download`\n- go to `/examples/...` and run `gleam run -m lustre/dev start`\n\n# features / todos\n\n✅ = done \\\n⚠️ = done but needs improvement \\\n💼 = gets worked on / comming soon \\\n❌ = not implemented yet \\\n⁉️ = not sure when and how to implement\n\n- ✅ Components / Default HTML Components\n    - Keep Fn as Children?\n- ✅ Parameter / ⁉️ Modifier (have been postponed for now)\n    - Attributes (class, style, ... | -&gt; value | init values) / Listener (onclick, ... | -&gt; fn -&gt; Nil | can change state) / Modifier (onrender, ... | -&gt; fn -&gt; List(Paramenter) | modify init values)\n- ✅ State\n    - State Parameter (Attributes / Listener that can be changed on state change)\n    - State Components (Components that can be changed on state change)\n    - 💼 State Map Function / ListState Type?? \\\n    eg: \\\n    use ListStateItem(value) &lt;- state_list.map(State(List(value))) --&gt; List(Component) \\\n    // value: ListStateItem(a), new_value: a, index: Int \\\n    state_list.remove(value) \\\n    state_list.move(value, index) \\\n    state_list.insert_before(value, new_value) \\\n    state_list.insert_after(value, new_value) \\\n    state_list.replace(value, new_value)\n    \n- ✅ Drag and Drop\n- 💼 Rich Text Editor\n- ❌ Router\n    - Make use of unrendered\n- ❌ Server Components\n- ❌ Resumability (like Qwik)\n\n- ⁉️ Backend (making use of Gleams compiling → Erlang / JavaScript)","url":"index.html"},{"doc":"cli/dev","title":"cli/dev","content":"","url":"cli/dev.html"},{"doc":"cli/esbuild","title":"cli/esbuild","content":"","url":"cli/esbuild.html"},{"doc":"novdom/component","title":"Component","content":"pub opaque type Component\n\n\nSynonyms:\nnovdom/component.Component\nnovdom/component Component","url":"novdom/component.html#Component"},{"doc":"novdom/component","title":"ComponentId","content":"pub type ComponentId =\n  String\n\n\nSynonyms:\nnovdom/component.ComponentId\nnovdom/component ComponentId","url":"novdom/component.html#ComponentId"},{"doc":"novdom/component","title":"component","content":"pub fn component(\n  tag: String,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component.component\nnovdom/component component","url":"novdom/component.html#component"},{"doc":"novdom/component","title":"copy","content":"pub fn copy(comp: Component) -&gt; Component\n\nSynonyms:\nnovdom/component.copy\nnovdom/component copy","url":"novdom/component.html#copy"},{"doc":"novdom/component","title":"document","content":"pub fn document() -&gt; Component\n\nSynonyms:\nnovdom/component.document\nnovdom/component document","url":"novdom/component.html#document"},{"doc":"novdom/component","title":"drag_component","content":"pub fn drag_component() -&gt; Component\n\nSynonyms:\nnovdom/component.drag_component\nnovdom/component drag_component","url":"novdom/component.html#drag_component"},{"doc":"novdom/component","title":"get_component","content":"pub fn get_component(id: String) -&gt; Component\n\nSynonyms:\nnovdom/component.get_component\nnovdom/component get_component","url":"novdom/component.html#get_component"},{"doc":"novdom/component","title":"html","content":"pub fn html(value: String) -&gt; Component\n gets wraped by a custom element tag (&lt;_HTML_&gt;)\nSynonyms:\nnovdom/component.html\nnovdom/component html","url":"novdom/component.html#html"},{"doc":"novdom/component","title":"insert_child_at","content":"pub fn insert_child_at(\n  comp: Component,\n  child: Component,\n  at: Int,\n) -&gt; Component\n\nSynonyms:\nnovdom/component.insert_child_at\nnovdom/component insert_child_at","url":"novdom/component.html#insert_child_at"},{"doc":"novdom/component","title":"insert_child_before","content":"pub fn insert_child_before(\n  comp: Component,\n  child: Component,\n  before_id: String,\n) -&gt; Component\n\nSynonyms:\nnovdom/component.insert_child_before\nnovdom/component insert_child_before","url":"novdom/component.html#insert_child_before"},{"doc":"novdom/component","title":"move_children","content":"pub fn move_children(from: Component, to: Component) -&gt; Nil\n\nSynonyms:\nnovdom/component.move_children\nnovdom/component move_children","url":"novdom/component.html#move_children"},{"doc":"novdom/component","title":"remove_child","content":"pub fn remove_child(\n  comp: Component,\n  child: Component,\n) -&gt; Component\n\nSynonyms:\nnovdom/component.remove_child\nnovdom/component remove_child","url":"novdom/component.html#remove_child"},{"doc":"novdom/component","title":"remove_child_at","content":"pub fn remove_child_at(comp: Component, at: Int) -&gt; Component\n\nSynonyms:\nnovdom/component.remove_child_at\nnovdom/component remove_child_at","url":"novdom/component.html#remove_child_at"},{"doc":"novdom/component","title":"set_children","content":"pub fn set_children(\n  comp: Component,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component.set_children\nnovdom/component set_children","url":"novdom/component.html#set_children"},{"doc":"novdom/component","title":"text","content":"pub fn text(value: String) -&gt; Component\n gets wraped by a custom element tag (&lt;_TEXT_&gt;)\nSynonyms:\nnovdom/component.text\nnovdom/component text","url":"novdom/component.html#text"},{"doc":"novdom/component","title":"novdom/component","content":"","url":"novdom/component.html"},{"doc":"novdom/attribute","title":"class","content":"pub fn class(value: String) -&gt; Parameter\n Adding classes to the component\n Concatenating the classes if the class attribute already exists\nSynonyms:\nnovdom/attribute.class\nnovdom/attribute class","url":"novdom/attribute.html#class"},{"doc":"novdom/attribute","title":"editable","content":"pub fn editable() -&gt; Parameter\n\nSynonyms:\nnovdom/attribute.editable\nnovdom/attribute editable","url":"novdom/attribute.html#editable"},{"doc":"novdom/attribute","title":"hidden","content":"pub fn hidden() -&gt; Parameter\n\nSynonyms:\nnovdom/attribute.hidden\nnovdom/attribute hidden","url":"novdom/attribute.html#hidden"},{"doc":"novdom/attribute","title":"style","content":"pub fn style(values: List(#(String, String))) -&gt; Parameter\n Adding inline-styles to the component\n Overriding the style attribute if it already exists\nSynonyms:\nnovdom/attribute.style\nnovdom/attribute style","url":"novdom/attribute.html#style"},{"doc":"novdom/attribute","title":"novdom/attribute","content":"","url":"novdom/attribute.html"},{"doc":"novdom/html","title":"div","content":"pub fn div(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/html.div\nnovdom/html div","url":"novdom/html.html#div"},{"doc":"novdom/html","title":"h1","content":"pub fn h1(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/html.h1\nnovdom/html h1","url":"novdom/html.html#h1"},{"doc":"novdom/html","title":"h2","content":"pub fn h2(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/html.h2\nnovdom/html h2","url":"novdom/html.html#h2"},{"doc":"novdom/html","title":"h3","content":"pub fn h3(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/html.h3\nnovdom/html h3","url":"novdom/html.html#h3"},{"doc":"novdom/html","title":"p","content":"pub fn p(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/html.p\nnovdom/html p","url":"novdom/html.html#p"},{"doc":"novdom/html","title":"span","content":"pub fn span(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/html.span\nnovdom/html span","url":"novdom/html.html#span"},{"doc":"novdom/html","title":"text","content":"pub fn text(\n  parameters: List(Parameter),\n  value: String,\n) -&gt; Component\n\nSynonyms:\nnovdom/html.text\nnovdom/html text","url":"novdom/html.html#text"},{"doc":"novdom/html","title":"textln","content":"pub fn textln(\n  parameters: List(Parameter),\n  value: String,\n) -&gt; Component\n\nSynonyms:\nnovdom/html.textln\nnovdom/html textln","url":"novdom/html.html#textln"},{"doc":"novdom/html","title":"novdom/html","content":"","url":"novdom/html.html"},{"doc":"novdom/container","title":"Alignment","content":"pub type Alignment {\n  Top\n  Bottom\n  Left\n  Right\n  Center\n  TopLeft\n  TopRight\n  BottomLeft\n  BottomRight\n}\n\nTop\n\n\nBottom\n\n\nLeft\n\n\nRight\n\n\nCenter\n\n\nTopLeft\n\n\nTopRight\n\n\nBottomLeft\n\n\nBottomRight\n\n\nSynonyms:\nnovdom/container.Alignment\nnovdom/container Alignment","url":"novdom/container.html#Alignment"},{"doc":"novdom/container","title":"Direction","content":"pub type Direction {\n  VerticalDirection\n  HorizontalDirection\n}\n\nVerticalDirection\n\n\nHorizontalDirection\n\n\nSynonyms:\nnovdom/container.Direction\nnovdom/container Direction","url":"novdom/container.html#Direction"},{"doc":"novdom/container","title":"Scroll","content":"pub type Scroll {\n  VerticalScroll\n  HorizontalScroll\n  Scroll\n  NoScroll\n}\n\nVerticalScroll\n\n\nHorizontalScroll\n\n\nScroll\n\n\nNoScroll\n\n\nSynonyms:\nnovdom/container.Scroll\nnovdom/container Scroll","url":"novdom/container.html#Scroll"},{"doc":"novdom/container","title":"Spacing","content":"pub type Spacing {\n  Gap(String)\n  NoSpacing\n  EvenSpacing\n  BetweenSpacing\n  AroundSpacing\n}\n\nGap(String)\n\n\nNoSpacing\n\n\nEvenSpacing\n\n\nBetweenSpacing\n\n\nAroundSpacing\n\n\nSynonyms:\nnovdom/container.Spacing\nnovdom/container Spacing","url":"novdom/container.html#Spacing"},{"doc":"novdom/container","title":"hscroll","content":"pub fn hscroll(\n  alignment: Alignment,\n  spacing: Spacing,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/container.hscroll\nnovdom/container hscroll","url":"novdom/container.html#hscroll"},{"doc":"novdom/container","title":"hstack","content":"pub fn hstack(\n  alignment: Alignment,\n  spacing: Spacing,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/container.hstack\nnovdom/container hstack","url":"novdom/container.html#hstack"},{"doc":"novdom/container","title":"stack","content":"pub fn stack(\n  direction: Direction,\n  alignment: Alignment,\n  spacing: Spacing,\n  scrolling: Scroll,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/container.stack\nnovdom/container stack","url":"novdom/container.html#stack"},{"doc":"novdom/container","title":"vscroll","content":"pub fn vscroll(\n  alignment: Alignment,\n  spacing: Spacing,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/container.vscroll\nnovdom/container vscroll","url":"novdom/container.html#vscroll"},{"doc":"novdom/container","title":"vstack","content":"pub fn vstack(\n  alignment: Alignment,\n  spacing: Spacing,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/container.vstack\nnovdom/container vstack","url":"novdom/container.html#vstack"},{"doc":"novdom/container","title":"zstack","content":"pub fn zstack(\n  alignment: Alignment,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/container.zstack\nnovdom/container zstack","url":"novdom/container.html#zstack"},{"doc":"novdom/container","title":"novdom/container","content":"","url":"novdom/container.html"},{"doc":"novdom/listener","title":"create_once","content":"pub fn create_once(\n  callback: fn(Event) -&gt; Nil,\n) -&gt; fn(Event) -&gt; Nil\n\nSynonyms:\nnovdom/listener.create_once\nnovdom/listener create_once","url":"novdom/listener.html#create_once"},{"doc":"novdom/listener","title":"once","content":"pub fn once(listener: Parameter) -&gt; Parameter\n Creates a listener that will only be called once\n *WARNING:* If anything else than a Listener is passed, this function will panic\nSynonyms:\nnovdom/listener.once\nnovdom/listener once","url":"novdom/listener.html#once"},{"doc":"novdom/listener","title":"onclick","content":"pub fn onclick(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n\nSynonyms:\nnovdom/listener.onclick\nnovdom/listener onclick","url":"novdom/listener.html#onclick"},{"doc":"novdom/listener","title":"onemouseover","content":"pub fn onemouseover(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n\nSynonyms:\nnovdom/listener.onemouseover\nnovdom/listener onemouseover","url":"novdom/listener.html#onemouseover"},{"doc":"novdom/listener","title":"onkeydown","content":"pub fn onkeydown(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n\nSynonyms:\nnovdom/listener.onkeydown\nnovdom/listener onkeydown","url":"novdom/listener.html#onkeydown"},{"doc":"novdom/listener","title":"onmousedown","content":"pub fn onmousedown(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n\nSynonyms:\nnovdom/listener.onmousedown\nnovdom/listener onmousedown","url":"novdom/listener.html#onmousedown"},{"doc":"novdom/listener","title":"onmousemove","content":"pub fn onmousemove(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n\nSynonyms:\nnovdom/listener.onmousemove\nnovdom/listener onmousemove","url":"novdom/listener.html#onmousemove"},{"doc":"novdom/listener","title":"onmouseout","content":"pub fn onmouseout(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n\nSynonyms:\nnovdom/listener.onmouseout\nnovdom/listener onmouseout","url":"novdom/listener.html#onmouseout"},{"doc":"novdom/listener","title":"onmouseup","content":"pub fn onmouseup(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n\nSynonyms:\nnovdom/listener.onmouseup\nnovdom/listener onmouseup","url":"novdom/listener.html#onmouseup"},{"doc":"novdom/listener","title":"novdom/listener","content":"","url":"novdom/listener.html"},{"doc":"novdom/hotkey","title":"Hotkey","content":"pub type Hotkey {\n  Hotkey(code: String, modifiers: List(Modifier))\n}\n\nHotkey(code: String, modifiers: List(Modifier))\n\n\nSynonyms:\nnovdom/hotkey.Hotkey\nnovdom/hotkey Hotkey","url":"novdom/hotkey.html#Hotkey"},{"doc":"novdom/hotkey","title":"HotkeyId","content":"pub type HotkeyId =\n  String\n\n\nSynonyms:\nnovdom/hotkey.HotkeyId\nnovdom/hotkey HotkeyId","url":"novdom/hotkey.html#HotkeyId"},{"doc":"novdom/hotkey","title":"HotkeyOption","content":"pub type HotkeyOption {\n  Key(Hotkey)\n  Id(HotkeyId)\n}\n\nKey(Hotkey)\n\n\nId(HotkeyId)\n\n\nSynonyms:\nnovdom/hotkey.HotkeyOption\nnovdom/hotkey HotkeyOption","url":"novdom/hotkey.html#HotkeyOption"},{"doc":"novdom/hotkey","title":"Modifier","content":"pub type Modifier {\n  Shift\n  Alt\n  Short\n}\n\nShift\n\n\nAlt\n\n\nShort\n\n\nSynonyms:\nnovdom/hotkey.Modifier\nnovdom/hotkey Modifier","url":"novdom/hotkey.html#Modifier"},{"doc":"novdom/hotkey","title":"add","content":"pub fn add(id: String, key: Hotkey) -&gt; Nil\n\nSynonyms:\nnovdom/hotkey.add\nnovdom/hotkey add","url":"novdom/hotkey.html#add"},{"doc":"novdom/hotkey","title":"configure_ids","content":"pub fn configure_ids(\n  config: List(#(String, List(Hotkey))),\n) -&gt; Nil\n\nSynonyms:\nnovdom/hotkey.configure_ids\nnovdom/hotkey configure_ids","url":"novdom/hotkey.html#configure_ids"},{"doc":"novdom/hotkey","title":"get_ids","content":"pub fn get_ids(key: Hotkey) -&gt; List(String)\n\nSynonyms:\nnovdom/hotkey.get_ids\nnovdom/hotkey get_ids","url":"novdom/hotkey.html#get_ids"},{"doc":"novdom/hotkey","title":"get_keys","content":"pub fn get_keys(id: String) -&gt; List(Hotkey)\n\nSynonyms:\nnovdom/hotkey.get_keys\nnovdom/hotkey get_keys","url":"novdom/hotkey.html#get_keys"},{"doc":"novdom/hotkey","title":"init","content":"pub fn init() -&gt; Nil\n\nSynonyms:\nnovdom/hotkey.init\nnovdom/hotkey init","url":"novdom/hotkey.html#init"},{"doc":"novdom/hotkey","title":"keypress_callback","content":"pub fn keypress_callback(e: Event) -&gt; Nil\n\nSynonyms:\nnovdom/hotkey.keypress_callback\nnovdom/hotkey keypress_callback","url":"novdom/hotkey.html#keypress_callback"},{"doc":"novdom/hotkey","title":"override","content":"pub fn override(id: String, key: Hotkey) -&gt; Nil\n\nSynonyms:\nnovdom/hotkey.override\nnovdom/hotkey override","url":"novdom/hotkey.html#override"},{"doc":"novdom/hotkey","title":"remove","content":"pub fn remove(id: String, key: Hotkey) -&gt; Nil\n\nSynonyms:\nnovdom/hotkey.remove\nnovdom/hotkey remove","url":"novdom/hotkey.html#remove"},{"doc":"novdom/hotkey","title":"set_hotkey_listener","content":"pub fn set_hotkey_listener(\n  id: String,\n  callback: fn(Event) -&gt; Nil,\n) -&gt; Nil\n\nSynonyms:\nnovdom/hotkey.set_hotkey_listener\nnovdom/hotkey set_hotkey_listener","url":"novdom/hotkey.html#set_hotkey_listener"},{"doc":"novdom/hotkey","title":"with_hotkey","content":"pub fn with_hotkey(\n  option: HotkeyOption,\n  callback: fn(Event) -&gt; Nil,\n) -&gt; fn(Event) -&gt; Nil\n\nSynonyms:\nnovdom/hotkey.with_hotkey\nnovdom/hotkey with_hotkey","url":"novdom/hotkey.html#with_hotkey"},{"doc":"novdom/hotkey","title":"novdom/hotkey","content":"","url":"novdom/hotkey.html"},{"doc":"novdom/render","title":"add_to_viewport","content":"pub fn add_to_viewport(comp: Component, id: String) -&gt; Nil\n\nSynonyms:\nnovdom/render.add_to_viewport\nnovdom/render add_to_viewport","url":"novdom/render.html#add_to_viewport"},{"doc":"novdom/render","title":"clear_viewport","content":"pub fn clear_viewport(id: String) -&gt; Nil\n\nSynonyms:\nnovdom/render.clear_viewport\nnovdom/render clear_viewport","url":"novdom/render.html#clear_viewport"},{"doc":"novdom/render","title":"novdom/render","content":"","url":"novdom/render.html"},{"doc":"novdom/state","title":"State","content":"pub type State(a) {\n  State(state_id: String)\n  StateItem(state_id: String, item_id: String)\n}\n\nState(state_id: String)\n\n\nStateItem(state_id: String, item_id: String)\n\n\nSynonyms:\nnovdom/state.State\nnovdom/state State","url":"novdom/state.html#State"},{"doc":"novdom/state","title":"create","content":"pub fn create(init: a) -&gt; State(a)\n\nSynonyms:\nnovdom/state.create\nnovdom/state create","url":"novdom/state.html#create"},{"doc":"novdom/state","title":"create_with_id","content":"pub fn create_with_id(id: String, init: a) -&gt; State(a)\n\nSynonyms:\nnovdom/state.create_with_id\nnovdom/state create_with_id","url":"novdom/state.html#create_with_id"},{"doc":"novdom/state","title":"from_id","content":"pub fn from_id(id: String) -&gt; State(a)\n\nSynonyms:\nnovdom/state.from_id\nnovdom/state from_id","url":"novdom/state.html#from_id"},{"doc":"novdom/state","title":"listen","content":"pub fn listen(state: State(a), callback: fn(a) -&gt; Nil) -&gt; Nil\n\nSynonyms:\nnovdom/state.listen\nnovdom/state listen","url":"novdom/state.html#listen"},{"doc":"novdom/state","title":"update","content":"pub fn update(state: State(a), new: a) -&gt; Nil\n update value\nSynonyms:\nnovdom/state.update\nnovdom/state update","url":"novdom/state.html#update"},{"doc":"novdom/state","title":"value","content":"pub fn value(state: State(a)) -&gt; a\n get value\nSynonyms:\nnovdom/state.value\nnovdom/state value","url":"novdom/state.html#value"},{"doc":"novdom/state","title":"novdom/state","content":"","url":"novdom/state.html"},{"doc":"novdom/state_parameter","title":"if1","content":"pub fn if1(\n  state: State(a),\n  when: fn(a) -&gt; Bool,\n  then: List(Parameter),\n) -&gt; Parameter\n\nSynonyms:\nnovdom/state_parameter.if1\nnovdom/state_parameter if1","url":"novdom/state_parameter.html#if1"},{"doc":"novdom/state_parameter","title":"if2","content":"pub fn if2(\n  state1: State(a),\n  state2: State(b),\n  when: fn(a, b) -&gt; Bool,\n  then: List(Parameter),\n) -&gt; Parameter\n\nSynonyms:\nnovdom/state_parameter.if2\nnovdom/state_parameter if2","url":"novdom/state_parameter.html#if2"},{"doc":"novdom/state_parameter","title":"ternary1","content":"pub fn ternary1(\n  state: State(a),\n  when: fn(a) -&gt; Bool,\n  then: List(Parameter),\n  otherwise: List(Parameter),\n) -&gt; Parameter\n\nSynonyms:\nnovdom/state_parameter.ternary1\nnovdom/state_parameter ternary1","url":"novdom/state_parameter.html#ternary1"},{"doc":"novdom/state_parameter","title":"utilize","content":"pub fn utilize(\n  state: State(a),\n  do: fn(a) -&gt; List(Parameter),\n) -&gt; Parameter\n\nSynonyms:\nnovdom/state_parameter.utilize\nnovdom/state_parameter utilize","url":"novdom/state_parameter.html#utilize"},{"doc":"novdom/state_parameter","title":"novdom/state_parameter","content":"","url":"novdom/state_parameter.html"},{"doc":"novdom/state_component","title":"if1","content":"pub fn if1(\n  state: State(a),\n  when: fn(a) -&gt; Bool,\n  then: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/state_component.if1\nnovdom/state_component if1","url":"novdom/state_component.html#if1"},{"doc":"novdom/state_component","title":"ternary1","content":"pub fn ternary1(\n  state: State(a),\n  when: fn(a) -&gt; Bool,\n  then: List(Component),\n  otherwise: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/state_component.ternary1\nnovdom/state_component ternary1","url":"novdom/state_component.html#ternary1"},{"doc":"novdom/state_component","title":"utilize","content":"pub fn utilize(\n  state: State(a),\n  do: fn(a) -&gt; List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/state_component.utilize\nnovdom/state_component utilize","url":"novdom/state_component.html#utilize"},{"doc":"novdom/state_component","title":"novdom/state_component","content":"","url":"novdom/state_component.html"},{"doc":"novdom/motion","title":"DragEvent","content":"pub type DragEvent(a) {\n  DragEvent(\n    value: a,\n    preview: Component,\n    drop: fn(DragEvent(a)) -&gt; Nil,\n    cancel: fn(DragEvent(a), fn() -&gt; Nil) -&gt; Nil,\n    droppable: Bool,\n  )\n}\n\nDragEvent(\n  value: a,\n  preview: Component,\n  drop: fn(DragEvent(a)) -&gt; Nil,\n  cancel: fn(DragEvent(a), fn() -&gt; Nil) -&gt; Nil,\n  droppable: Bool,\n)\n\n\nSynonyms:\nnovdom/motion.DragEvent\nnovdom/motion DragEvent","url":"novdom/motion.html#DragEvent"},{"doc":"novdom/motion","title":"PreviewType","content":"pub type PreviewType {\n  Preview(Component)\n  Self\n}\n\nPreview(Component)\n\n\nSelf\n\n\nSynonyms:\nnovdom/motion.PreviewType\nnovdom/motion PreviewType","url":"novdom/motion.html#PreviewType"},{"doc":"novdom/motion","title":"init","content":"pub fn init() -&gt; Component\n\nSynonyms:\nnovdom/motion.init\nnovdom/motion init","url":"novdom/motion.html#init"},{"doc":"novdom/motion","title":"ondrag","content":"pub fn ondrag(\n  preview_type: PreviewType,\n  value: a,\n  on_drag: fn(DragEvent(a)) -&gt; Nil,\n  on_cancel: fn(DragEvent(a), fn() -&gt; Nil) -&gt; Nil,\n  on_drop: fn(DragEvent(a)) -&gt; Nil,\n) -&gt; Parameter\n\nSynonyms:\nnovdom/motion.ondrag\nnovdom/motion ondrag","url":"novdom/motion.html#ondrag"},{"doc":"novdom/motion","title":"ondrop","content":"pub fn ondrop(\n  on_drag: fn(DragEvent(a)) -&gt; Nil,\n  on_hover: fn(DragEvent(a)) -&gt; Bool,\n  on_drop: fn(DragEvent(a), fn() -&gt; Nil) -&gt; Nil,\n) -&gt; Parameter\n\nSynonyms:\nnovdom/motion.ondrop\nnovdom/motion ondrop","url":"novdom/motion.html#ondrop"},{"doc":"novdom/motion","title":"store_mouse_position","content":"pub fn store_mouse_position(event: Event) -&gt; Nil\n\nSynonyms:\nnovdom/motion.store_mouse_position\nnovdom/motion store_mouse_position","url":"novdom/motion.html#store_mouse_position"},{"doc":"novdom/motion","title":"novdom/motion","content":"","url":"novdom/motion.html"},{"doc":"novdom/framework","title":"start","content":"pub fn start(component: fn() -&gt; Component) -&gt; Nil\n\nSynonyms:\nnovdom/framework.start\nnovdom/framework start","url":"novdom/framework.html#start"},{"doc":"novdom/framework","title":"novdom/framework","content":"","url":"novdom/framework.html"},{"doc":"novdom/modifier","title":"novdom/modifier","content":"","url":"novdom/modifier.html"},{"doc":"novdom/position","title":"novdom/position","content":"","url":"novdom/position.html"},{"doc":"novdom/reference","title":"Reference","content":"pub type Reference {\n  Reference(id: String)\n}\n\nReference(id: String)\n\n\nSynonyms:\nnovdom/reference.Reference\nnovdom/reference Reference","url":"novdom/reference.html#Reference"},{"doc":"novdom/reference","title":"ReferenceType","content":"pub type ReferenceType {\n  Value\n  InnerHTML\n}\n\nValue\n\n\nInnerHTML\n\n\nSynonyms:\nnovdom/reference.ReferenceType\nnovdom/reference ReferenceType","url":"novdom/reference.html#ReferenceType"},{"doc":"novdom/reference","title":"create","content":"pub fn create() -&gt; Reference\n\nSynonyms:\nnovdom/reference.create\nnovdom/reference create","url":"novdom/reference.html#create"},{"doc":"novdom/reference","title":"from_id","content":"pub fn from_id(id: String) -&gt; Reference\n\nSynonyms:\nnovdom/reference.from_id\nnovdom/reference from_id","url":"novdom/reference.html#from_id"},{"doc":"novdom/reference","title":"set","content":"pub fn set(ref: Reference, ref_type: ReferenceType) -&gt; Parameter\n\nSynonyms:\nnovdom/reference.set\nnovdom/reference set","url":"novdom/reference.html#set"},{"doc":"novdom/reference","title":"value","content":"pub fn value(ref: Reference) -&gt; String\n\nSynonyms:\nnovdom/reference.value\nnovdom/reference value","url":"novdom/reference.html#value"},{"doc":"novdom/reference","title":"novdom/reference","content":"","url":"novdom/reference.html"},{"doc":"novdom/rich_text","title":"Delta","content":"pub type Delta\n\n\nSynonyms:\nnovdom/rich_text.Delta\nnovdom/rich_text Delta","url":"novdom/rich_text.html#Delta"},{"doc":"novdom/rich_text","title":"Format","content":"pub type Format {\n  Bold\n  Italic\n  Underline\n}\n\nBold\n\n\nItalic\n\n\nUnderline\n\n\nSynonyms:\nnovdom/rich_text.Format\nnovdom/rich_text Format","url":"novdom/rich_text.html#Format"},{"doc":"novdom/rich_text","title":"Quill","content":"pub type Quill\n\n\nSynonyms:\nnovdom/rich_text.Quill\nnovdom/rich_text Quill","url":"novdom/rich_text.html#Quill"},{"doc":"novdom/rich_text","title":"RichTextStore","content":"pub opaque type RichTextStore\n\n\nSynonyms:\nnovdom/rich_text.RichTextStore\nnovdom/rich_text RichTextStore","url":"novdom/rich_text.html#RichTextStore"},{"doc":"novdom/rich_text","title":"delta","content":"pub fn delta(store: RichTextStore) -&gt; Delta\n\nSynonyms:\nnovdom/rich_text.delta\nnovdom/rich_text delta","url":"novdom/rich_text.html#delta"},{"doc":"novdom/rich_text","title":"editor","content":"pub fn editor(store: RichTextStore) -&gt; Component\n\nSynonyms:\nnovdom/rich_text.editor\nnovdom/rich_text editor","url":"novdom/rich_text.html#editor"},{"doc":"novdom/rich_text","title":"format","content":"pub fn format(store: RichTextStore, format: Format) -&gt; Delta\n\nSynonyms:\nnovdom/rich_text.format\nnovdom/rich_text format","url":"novdom/rich_text.html#format"},{"doc":"novdom/rich_text","title":"store","content":"pub fn store() -&gt; RichTextStore\n\nSynonyms:\nnovdom/rich_text.store\nnovdom/rich_text store","url":"novdom/rich_text.html#store"},{"doc":"novdom/rich_text","title":"text","content":"pub fn text(store: RichTextStore) -&gt; String\n\nSynonyms:\nnovdom/rich_text.text\nnovdom/rich_text text","url":"novdom/rich_text.html#text"},{"doc":"novdom/rich_text","title":"novdom/rich_text","content":"","url":"novdom/rich_text.html"}]);